<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>lib.handle.handle_hist &mdash; RDstar_light  documentation</title>
      <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="../../../" id="documentation_options" src="../../../_static/documentation_options.js"></script>
        <script src="../../../_static/jquery.js"></script>
        <script src="../../../_static/underscore.js"></script>
        <script src="../../../_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script src="../../../_static/doctools.js"></script>
    <script src="../../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
            <a href="../../../index.html" class="icon icon-home"> RDstar_light
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../../lib.html">lib package</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../scripts.html">scripts.multiple_candidates package</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">RDstar_light</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../../index.html" class="icon icon-home"></a> &raquo;</li>
          <li><a href="../../index.html">Module code</a> &raquo;</li>
      <li>lib.handle.handle_hist</li>
      <li class="wy-breadcrumbs-aside">
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <h1>Source code for lib.handle.handle_hist</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot; Module to build histograms.</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="kn">from</span> <span class="nn">typing</span> <span class="kn">import</span> <span class="n">Optional</span><span class="p">,</span> <span class="n">Union</span><span class="p">,</span> <span class="n">Tuple</span><span class="p">,</span> <span class="n">List</span>

<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
<span class="kn">import</span> <span class="nn">pandas</span> <span class="k">as</span> <span class="nn">pd</span>

<span class="kn">from</span> <span class="nn">.handle_list</span> <span class="kn">import</span> <span class="n">el_to_list</span>
<span class="kn">from</span> <span class="nn">.handle_sample</span> <span class="kn">import</span> <span class="n">compute_low_high</span>
<span class="kn">from</span> <span class="nn">.._typing</span> <span class="kn">import</span> <span class="n">ArrayLike</span><span class="p">,</span> <span class="n">SamplesLike</span><span class="p">,</span> <span class="n">Density</span>


<div class="viewcode-block" id="get_bin_width"><a class="viewcode-back" href="../../../lib.handle.html#lib.handle.handle_hist.get_bin_width">[docs]</a><span class="k">def</span> <span class="nf">get_bin_width</span><span class="p">(</span><span class="n">low</span><span class="p">:</span> <span class="nb">float</span><span class="p">,</span> <span class="n">high</span><span class="p">:</span> <span class="nb">float</span><span class="p">,</span> <span class="n">nb_bins</span><span class="p">:</span> <span class="nb">int</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;Return the bin width of the histogram (assuming equal-width bins!)</span>

<span class="sd">    Args:</span>
<span class="sd">        low: low value of the histogram</span>
<span class="sd">        high: high value of the histogram</span>
<span class="sd">        nb_bins: number of bins</span>

<span class="sd">    Returns:</span>
<span class="sd">        bin_width: Width of the bins</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">return</span> <span class="nb">float</span><span class="p">((</span><span class="n">high</span> <span class="o">-</span> <span class="n">low</span><span class="p">)</span> <span class="o">/</span> <span class="n">nb_bins</span><span class="p">)</span></div>


<div class="viewcode-block" id="get_edges_from_centres"><a class="viewcode-back" href="../../../lib.handle.html#lib.handle.handle_hist.get_edges_from_centres">[docs]</a><span class="k">def</span> <span class="nf">get_edges_from_centres</span><span class="p">(</span><span class="n">centres</span><span class="p">:</span> <span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;Get the bin edges of a histogram from the bin centres. The bins are</span>
<span class="sd">    supposed to be equal-sized.</span>

<span class="sd">    Args:</span>
<span class="sd">        centres: Bin centres of a histogram</span>

<span class="sd">    Returns:</span>
<span class="sd">        Bin edges of the histogram</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">bin_width</span> <span class="o">=</span> <span class="n">centres</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span> <span class="o">-</span> <span class="n">centres</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
    <span class="n">edges</span> <span class="o">=</span> <span class="n">centres</span> <span class="o">-</span> <span class="n">bin_width</span> <span class="o">/</span> <span class="mi">2</span>
    <span class="n">edges</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">edges</span><span class="p">,</span> <span class="n">centres</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="o">+</span> <span class="n">bin_width</span> <span class="o">/</span> <span class="mi">2</span><span class="p">)</span>

    <span class="k">return</span> <span class="n">edges</span></div>


<div class="viewcode-block" id="get_centres_from_edges"><a class="viewcode-back" href="../../../lib.handle.html#lib.handle.handle_hist.get_centres_from_edges">[docs]</a><span class="k">def</span> <span class="nf">get_centres_from_edges</span><span class="p">(</span><span class="n">edges</span><span class="p">:</span> <span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot; Get the bin centres of a histogram from the bin edges.</span>

<span class="sd">    Args:</span>
<span class="sd">        edges: Bin edges of a histogram</span>

<span class="sd">    Returns:</span>
<span class="sd">        Bin centres of the histogram</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">return</span> <span class="p">(</span><span class="n">edges</span><span class="p">[:</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="o">+</span> <span class="n">edges</span><span class="p">[</span><span class="mi">1</span><span class="p">:])</span> <span class="o">/</span> <span class="mi">2</span></div>


<div class="viewcode-block" id="get_centres_edges_from_bins"><a class="viewcode-back" href="../../../lib.handle.html#lib.handle.handle_hist.get_centres_edges_from_bins">[docs]</a><span class="k">def</span> <span class="nf">get_centres_edges_from_bins</span><span class="p">(</span><span class="n">bins</span><span class="p">:</span> <span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">,</span> <span class="n">nb_bins</span><span class="p">:</span> <span class="nb">int</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot; Assuming bins are either the bin centres or the bin edges,</span>
<span class="sd">    and given the number of bins in the histogram, return the bin</span>
<span class="sd">    centres and edges of the histogram.</span>

<span class="sd">    Args:</span>
<span class="sd">        bins: bin centres or bin edges</span>
<span class="sd">        nb_bins: number of bins in the histogram (usually obtained from</span>
<span class="sd">            the array of bin counts)</span>

<span class="sd">    return:</span>
<span class="sd">        bin centres and edges</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">bins</span><span class="p">)</span> <span class="o">==</span> <span class="n">nb_bins</span><span class="p">:</span>
        <span class="n">centres</span> <span class="o">=</span> <span class="n">bins</span>
        <span class="n">edges</span> <span class="o">=</span> <span class="n">get_edges_from_centres</span><span class="p">(</span><span class="n">centres</span><span class="p">)</span>
    <span class="k">elif</span> <span class="nb">len</span><span class="p">(</span><span class="n">bins</span><span class="p">)</span> <span class="o">==</span> <span class="n">nb_bins</span> <span class="o">+</span> <span class="mi">1</span><span class="p">:</span>
        <span class="n">edges</span> <span class="o">=</span> <span class="n">bins</span>
        <span class="n">centres</span> <span class="o">=</span> <span class="n">get_centres_from_edges</span><span class="p">(</span><span class="n">edges</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">raise</span> <span class="ne">ValueError</span><span class="p">(</span>
            <span class="s2">&quot;The size of `bins` must be equal to the size of `counts` &quot;</span>
            <span class="s2">&quot;or have one more elements&quot;</span>
        <span class="p">)</span>
    <span class="k">return</span> <span class="n">centres</span><span class="p">,</span> <span class="n">edges</span></div>


<div class="viewcode-block" id="get_equal_yield_bins_counts"><a class="viewcode-back" href="../../../lib.handle.html#lib.handle.handle_hist.get_equal_yield_bins_counts">[docs]</a><span class="k">def</span> <span class="nf">get_equal_yield_bins_counts</span><span class="p">(</span>
    <span class="n">data</span><span class="p">:</span> <span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">,</span> <span class="n">weights</span><span class="p">:</span> <span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">,</span> <span class="n">q</span><span class="p">:</span> <span class="nb">int</span>
<span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">]:</span>
    <span class="sd">&quot;&quot;&quot;Compute the bin edges of equal-yield bins. Taken from</span>
<span class="sd">    https://stackoverflow.com/questions/45528029/python-how-to-create-weighted-quantiles-in-pandas</span>

<span class="sd">    Args:</span>
<span class="sd">        data : array of values</span>
<span class="sd">        weights : array of weights for the values in ``data``</span>
<span class="sd">        q : number of bins</span>

<span class="sd">    Returns:</span>
<span class="sd">        bin counts and edges</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">assert</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">q</span><span class="p">,</span> <span class="nb">int</span><span class="p">)</span>
    <span class="n">quantiles</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">linspace</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="mi">1</span><span class="p">,</span> <span class="n">q</span> <span class="o">+</span> <span class="mi">1</span><span class="p">)</span>

    <span class="n">index_sort</span> <span class="o">=</span> <span class="n">data</span><span class="o">.</span><span class="n">argsort</span><span class="p">()</span><span class="o">.</span><span class="n">values</span>
    <span class="n">sorted_data</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">asarray</span><span class="p">(</span><span class="n">data</span><span class="p">)[</span><span class="n">index_sort</span><span class="p">]</span>

    <span class="k">if</span> <span class="n">weights</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">sorted_weights</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">ones</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">data</span><span class="p">))</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">sorted_weights</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">asarray</span><span class="p">(</span><span class="n">weights</span><span class="p">)[</span><span class="n">index_sort</span><span class="p">]</span>

    <span class="n">order</span> <span class="o">=</span> <span class="n">sorted_weights</span><span class="o">.</span><span class="n">cumsum</span><span class="p">()</span>

    <span class="n">df_p</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">()</span>
    <span class="n">df_p</span><span class="p">[</span><span class="s1">&#39;data&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">sorted_data</span>
    <span class="n">df_p</span><span class="p">[</span><span class="s1">&#39;weights&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">sorted_weights</span>
    <span class="n">df_p</span><span class="p">[</span><span class="s1">&#39;weighted_qcut&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">cut</span><span class="p">(</span><span class="n">order</span> <span class="o">/</span> <span class="n">order</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span> <span class="n">quantiles</span><span class="p">)</span>

    <span class="n">df_p_bins</span> <span class="o">=</span> <span class="n">df_p</span><span class="o">.</span><span class="n">groupby</span><span class="p">(</span><span class="s1">&#39;weighted_qcut&#39;</span><span class="p">)</span><span class="o">.</span><span class="n">agg</span><span class="p">({</span>
        <span class="s1">&#39;weights&#39;</span><span class="p">:</span> <span class="s1">&#39;sum&#39;</span><span class="p">,</span>
        <span class="s1">&#39;data&#39;</span><span class="p">:</span> <span class="p">[</span><span class="s1">&#39;min&#39;</span><span class="p">,</span> <span class="s1">&#39;max&#39;</span><span class="p">]</span>
    <span class="p">})</span>

    <span class="n">edges</span> <span class="o">=</span> <span class="n">df_p_bins</span><span class="p">[</span><span class="s1">&#39;data&#39;</span><span class="p">][</span><span class="s1">&#39;min&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">values</span>
    <span class="n">edges</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">edges</span><span class="p">,</span> <span class="n">df_p_bins</span><span class="p">[</span><span class="s1">&#39;data&#39;</span><span class="p">][</span><span class="s1">&#39;max&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">values</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">])</span>
    <span class="n">counts</span> <span class="o">=</span> <span class="n">df_p_bins</span><span class="p">[</span><span class="s1">&#39;weights&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">values</span><span class="o">.</span><span class="n">flatten</span><span class="p">()</span>
    <span class="k">return</span> <span class="n">counts</span><span class="p">,</span> <span class="n">edges</span></div>


<div class="viewcode-block" id="normalise_counts_err"><a class="viewcode-back" href="../../../lib.handle.html#lib.handle.handle_hist.normalise_counts_err">[docs]</a><span class="k">def</span> <span class="nf">normalise_counts_err</span><span class="p">(</span>
    <span class="n">counts</span><span class="p">:</span> <span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">,</span> <span class="n">bin_width</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="nb">float</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
    <span class="n">err</span><span class="p">:</span> <span class="n">np</span><span class="o">.</span><span class="n">ndarray</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span> <span class="n">density</span><span class="p">:</span> <span class="n">Density</span> <span class="o">=</span> <span class="s2">&quot;candidates&quot;</span>
<span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Union</span><span class="p">[</span><span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">,</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">]]:</span>
    <span class="sd">&quot;&quot;&quot; Normalise arrays of bins counts and errors on counts.</span>

<span class="sd">    Args:</span>
<span class="sd">        counts (np.ndarray): counts on a histogam</span>
<span class="sd">        bin_width (float or None): bin width of the histogram.</span>
<span class="sd">        err (np.array) : count errors</span>
<span class="sd">        density (str or False/None): 3 kinds of normalisation are possible</span>

<span class="sd">        * ``candidates``: just divide by the total number of counts</span>
<span class="sd">        * ``bin_width``: just divide by the bin width (pretty weird)</span>
<span class="sd">        * ``both`` (or `True`): divide by the total number of counts and \</span>
<span class="sd">            by the bin width</span>

<span class="sd">    Returns:</span>
<span class="sd">        :</span>

<span class="sd">        * normalised_counts: normalised bin counts</span>
<span class="sd">        * normalised_err: normalised bin errors (only if  ``err`` was \</span>
<span class="sd">            given)</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">if</span> <span class="n">bin_width</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">bin_width</span> <span class="o">=</span> <span class="mi">1</span>

    <span class="k">if</span> <span class="n">density</span> <span class="o">==</span> <span class="s2">&quot;candidates&quot;</span><span class="p">:</span>
        <span class="n">n_candidates</span> <span class="o">=</span> <span class="n">counts</span><span class="o">.</span><span class="n">sum</span><span class="p">()</span>
        <span class="n">diviser</span> <span class="o">=</span> <span class="n">n_candidates</span>
    <span class="k">elif</span> <span class="n">density</span> <span class="o">==</span> <span class="s2">&quot;bin_width&quot;</span><span class="p">:</span>
        <span class="n">diviser</span> <span class="o">=</span> <span class="n">bin_width</span>
    <span class="k">elif</span> <span class="n">density</span> <span class="o">==</span> <span class="s2">&quot;both&quot;</span> <span class="ow">or</span> <span class="n">density</span> <span class="ow">is</span> <span class="kc">True</span><span class="p">:</span>
        <span class="n">n_candidates</span> <span class="o">=</span> <span class="n">counts</span><span class="o">.</span><span class="n">sum</span><span class="p">()</span>
        <span class="n">diviser</span> <span class="o">=</span> <span class="n">n_candidates</span> <span class="o">*</span> <span class="n">bin_width</span>
    <span class="k">elif</span> <span class="p">(</span><span class="n">density</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">)</span> <span class="ow">or</span> <span class="p">(</span><span class="n">density</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">False</span><span class="p">):</span>
        <span class="k">raise</span> <span class="ne">ValueError</span><span class="p">(</span>
            <span class="s2">&quot;`density` should be either `candidates`, `bin_width`, `both`&quot;</span>
            <span class="sa">f</span><span class="s2">&quot; or `None` or `False`, but is </span><span class="si">{density}</span><span class="s2"> instead&quot;</span>
        <span class="p">)</span>

    <span class="n">counts</span> <span class="o">=</span> <span class="n">counts</span> <span class="o">/</span> <span class="n">diviser</span>
    <span class="n">err</span> <span class="o">=</span> <span class="n">err</span> <span class="o">/</span> <span class="n">diviser</span> <span class="k">if</span> <span class="n">err</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="k">else</span> <span class="kc">None</span>

    <span class="k">if</span> <span class="n">err</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">counts</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">counts</span><span class="p">,</span> <span class="n">err</span></div>


<div class="viewcode-block" id="get_counts_err"><a class="viewcode-back" href="../../../lib.handle.html#lib.handle.handle_hist.get_counts_err">[docs]</a><span class="k">def</span> <span class="nf">get_counts_err</span><span class="p">(</span>
    <span class="n">sample</span><span class="p">:</span> <span class="n">ArrayLike</span><span class="p">,</span> <span class="n">bins</span><span class="p">:</span> <span class="n">Union</span><span class="p">[</span><span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">,</span> <span class="nb">int</span><span class="p">],</span>
    <span class="n">weights</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
    <span class="n">low</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="nb">float</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span> <span class="n">high</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="nb">float</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
    <span class="n">density</span><span class="p">:</span> <span class="n">Density</span> <span class="o">=</span> <span class="kc">False</span><span class="p">,</span> <span class="n">equal_yield_bins</span><span class="p">:</span> <span class="nb">bool</span> <span class="o">=</span> <span class="kc">False</span><span class="p">,</span>
    <span class="o">**</span><span class="n">kwargs</span>
<span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">]:</span>
    <span class="sd">&quot;&quot;&quot;Get bin counts and errors of a list of values using</span>
<span class="sd">    :py:func:`numpy.histogram`</span>

<span class="sd">    Args:</span>
<span class="sd">        sample : sample for which we want to build a histogram</span>
<span class="sd">        bins : number of bins or bin edges</span>
<span class="sd">        weights : weights of each element in data</span>
<span class="sd">        low : low limit of the distribution</span>
<span class="sd">            (only if ``bins`` is not the array of bin edges)</span>
<span class="sd">        high : high limit of the distribution</span>
<span class="sd">            (only if ``bins`` is not the array of bin edges)</span>
<span class="sd">        density : 3 kinds of normalisation are possible</span>

<span class="sd">        * ``candidates``: just divide by the total number of counts</span>
<span class="sd">        * ``bin_width``: just divide by the bin width (pretty weird)</span>
<span class="sd">        * ``both``: divide by the total number of counts and by the bin width</span>

<span class="sd">        equal_yield_bins : whether to use equal-yield bins. in this case,</span>
<span class="sd">            ``bins`` must be the number of bins.</span>
<span class="sd">        **kwargs : passed to ``np.histogram``</span>

<span class="sd">    Returns:</span>
<span class="sd">        :</span>

<span class="sd">        * counts : number of counts in each bin</span>
<span class="sd">        * edges : bin edges</span>
<span class="sd">        * err : Errors in the counts of each bin</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">if</span> <span class="n">equal_yield_bins</span><span class="p">:</span>
        <span class="k">assert</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">bins</span><span class="p">,</span> <span class="nb">int</span><span class="p">),</span> <span class="p">(</span>
            <span class="s2">&quot;If `equal_yield_bins` is on, the bins are computed, and only &quot;</span>
            <span class="s2">&quot;the number of bins required should be given&quot;</span><span class="p">)</span>

        <span class="c1"># Cut the data according to the provided `low` and `high values`</span>
        <span class="n">sample_cut</span> <span class="o">=</span> <span class="n">sample</span>
        <span class="n">weights_cut</span> <span class="o">=</span> <span class="n">weights</span>

        <span class="k">if</span> <span class="n">low</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">cut</span> <span class="o">=</span> <span class="n">sample_cut</span> <span class="o">&gt;</span> <span class="n">low</span>
            <span class="n">sample_cut</span> <span class="o">=</span> <span class="n">sample_cut</span><span class="p">[</span><span class="n">cut</span><span class="p">]</span>
            <span class="k">if</span> <span class="n">weights</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                <span class="n">weights_cut</span> <span class="o">=</span> <span class="n">weights_cut</span><span class="p">[</span><span class="n">cut</span><span class="p">]</span>
        <span class="k">if</span> <span class="n">high</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">cut</span> <span class="o">=</span> <span class="n">sample_cut</span> <span class="o">&lt;</span> <span class="n">high</span>
            <span class="n">sample_cut</span> <span class="o">=</span> <span class="n">sample_cut</span><span class="p">[</span><span class="n">cut</span><span class="p">]</span>
            <span class="k">if</span> <span class="n">weights</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                <span class="n">weights_cut</span> <span class="o">=</span> <span class="n">weights_cut</span><span class="p">[</span><span class="n">cut</span><span class="p">]</span>

        <span class="c1"># Histogram</span>
        <span class="n">counts</span><span class="p">,</span> <span class="n">edges</span> <span class="o">=</span> <span class="n">get_equal_yield_bins_counts</span><span class="p">(</span>
            <span class="n">sample_cut</span><span class="p">,</span> <span class="n">weights_cut</span><span class="p">,</span> <span class="n">q</span><span class="o">=</span><span class="n">bins</span><span class="p">)</span>

        <span class="c1"># New low and high values</span>
        <span class="k">if</span> <span class="n">low</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">edges</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">=</span> <span class="n">low</span>
        <span class="k">if</span> <span class="n">high</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">edges</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="o">=</span> <span class="n">high</span>

        <span class="n">bins</span> <span class="o">=</span> <span class="n">edges</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="c1"># Range</span>
        <span class="k">if</span> <span class="n">low</span> <span class="ow">is</span> <span class="kc">None</span> <span class="ow">or</span> <span class="n">high</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">range_var</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">assert</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">bins</span><span class="p">,</span> <span class="nb">int</span><span class="p">),</span> <span class="p">(</span>
                <span class="s2">&quot;If low and high are given, `bins` must be the number of &quot;</span>
                <span class="sa">f</span><span class="s2">&quot; bins, hence an integer, but it is </span><span class="si">{bins}</span><span class="s2">&quot;</span><span class="p">)</span>
            <span class="n">range_var</span> <span class="o">=</span> <span class="p">(</span><span class="n">low</span><span class="p">,</span> <span class="n">high</span><span class="p">)</span>

        <span class="c1"># Histogram</span>
        <span class="n">counts</span><span class="p">,</span> <span class="n">edges</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">histogram</span><span class="p">(</span><span class="n">sample</span><span class="p">,</span> <span class="nb">range</span><span class="o">=</span><span class="n">range_var</span><span class="p">,</span>
                                     <span class="n">bins</span><span class="o">=</span><span class="n">bins</span><span class="p">,</span> <span class="n">weights</span><span class="o">=</span><span class="n">weights</span><span class="p">,</span>
                                     <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span>

        <span class="n">err</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">sqrt</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">abs</span><span class="p">(</span><span class="n">counts</span><span class="p">))</span>

    <span class="k">if</span> <span class="n">density</span><span class="p">:</span>  <span class="c1"># Normalisating</span>
        <span class="k">if</span> <span class="n">equal_yield_bins</span><span class="p">:</span>
            <span class="n">bin_width</span> <span class="o">=</span> <span class="kc">None</span>
            <span class="k">assert</span> <span class="n">density</span> <span class="o">!=</span> <span class="s2">&quot;both&quot;</span> <span class="ow">and</span> <span class="n">density</span> <span class="o">!=</span> <span class="s2">&quot;bin_width&quot;</span><span class="p">,</span> <span class="p">(</span>
                <span class="s2">&quot;Cannot normalise by the bin width of equal-yield bins &quot;</span>
                <span class="s2">&quot;as it is not a constant&quot;</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">bin_width</span> <span class="o">=</span> <span class="n">get_bin_width</span><span class="p">(</span><span class="n">edges</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="n">edges</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span> <span class="nb">len</span><span class="p">(</span><span class="n">counts</span><span class="p">))</span>

        <span class="n">counts</span><span class="p">,</span> <span class="n">err</span> <span class="o">=</span> <span class="n">normalise_counts_err</span><span class="p">(</span>
            <span class="n">counts</span><span class="p">,</span> <span class="n">err</span><span class="o">=</span><span class="n">err</span><span class="p">,</span>
            <span class="n">bin_width</span><span class="o">=</span><span class="n">bin_width</span><span class="p">,</span>
            <span class="n">density</span><span class="o">=</span><span class="n">density</span>
        <span class="p">)</span>
    <span class="k">return</span> <span class="n">counts</span><span class="p">,</span> <span class="n">edges</span><span class="p">,</span> <span class="n">err</span></div>


<div class="viewcode-block" id="dataframes_into_hist_1d"><a class="viewcode-back" href="../../../lib.handle.html#lib.handle.handle_hist.dataframes_into_hist_1d">[docs]</a><span class="k">def</span> <span class="nf">dataframes_into_hist_1d</span><span class="p">(</span>
    <span class="n">samples</span><span class="p">:</span> <span class="n">SamplesLike</span><span class="p">,</span>
    <span class="n">column</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="nb">str</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
    <span class="n">bins</span><span class="p">:</span> <span class="n">Union</span><span class="p">[</span><span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">,</span> <span class="nb">int</span><span class="p">]</span> <span class="o">=</span> <span class="mi">50</span><span class="p">,</span>
    <span class="n">low</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="nb">float</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span> <span class="n">high</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="nb">float</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
    <span class="n">weights</span><span class="p">:</span> <span class="n">np</span><span class="o">.</span><span class="n">ndarray</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
    <span class="n">density</span><span class="p">:</span> <span class="n">Density</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
    <span class="n">equal_yield_bins</span><span class="p">:</span> <span class="nb">float</span> <span class="o">=</span> <span class="kc">False</span><span class="p">,</span>
    <span class="o">**</span><span class="n">kwargs</span>
<span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">List</span><span class="p">[</span><span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">],</span> <span class="n">List</span><span class="p">[</span><span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">],</span> <span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">]:</span>
    <span class="sd">&quot;&quot;&quot;Turn a list of dataframes into a histogram</span>

<span class="sd">    Args:</span>
<span class="sd">        samples: one Pandas dataframe or a list of Pandas DataFrame</span>
<span class="sd">            or a series of numbers or a list of them</span>
<span class="sd">        column: name of the columns to plot, in the case one of the</span>
<span class="sd">            sample given is a full dataframe from which we must only select</span>
<span class="sd">            one column</span>
<span class="sd">        low: low limit of the distribution</span>
<span class="sd">            (only if ``bins`` is not the array of bin edges)</span>
<span class="sd">        high: high limit of the distribution</span>
<span class="sd">            (only if ``bins`` is not the array of bin edges)</span>
<span class="sd">        bins: Desired number of bins of the histogram,</span>
<span class="sd">            or bin edges</span>
<span class="sd">        weights: weights passed</span>
<span class="sd">            to  :py:func:`np.histogram`, or name of a column</span>
<span class="sd">            in the dataframes of ``samples``</span>
<span class="sd">        density: 3 kinds of normalisation are possible</span>

<span class="sd">        * ``candidates``: just divide by the total number of counts</span>
<span class="sd">        * ``bin_width``: just divide by the bin width (pretty weird)</span>
<span class="sd">        * ``both``: divide by the total number of counts and by the \</span>
<span class="sd">            bin width</span>

<span class="sd">        equal_yield_bins : whether to use equal-yield bins</span>
<span class="sd">        **kwargs : passed to :py:func:`HEA.tools.dist.get_counts_err`</span>

<span class="sd">    Returns:</span>
<span class="sd">        :</span>

<span class="sd">        * list_counts: list of bin counts for each sample in ``samples``</span>
<span class="sd">        * list_err: list of uncertainties on bin counts for each sample \</span>
<span class="sd">            in ``samples``</span>
<span class="sd">        * edges: common bin edges of all the histograms</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="c1"># One sample -&gt; a list of samples</span>
    <span class="k">if</span> <span class="ow">not</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">samples</span><span class="p">,</span> <span class="nb">list</span><span class="p">):</span>
        <span class="n">samples</span> <span class="o">=</span> <span class="p">[</span><span class="n">samples</span><span class="p">]</span>

    <span class="c1"># get the correct column and weights</span>
    <span class="k">if</span> <span class="n">weights</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">weights</span> <span class="o">=</span> <span class="n">el_to_list</span><span class="p">(</span><span class="n">weights</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="n">samples</span><span class="p">))</span>

    <span class="n">list_samples_column</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">sample</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">samples</span><span class="p">):</span>
        <span class="k">if</span> <span class="n">weights</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">weights</span><span class="p">[</span><span class="n">i</span><span class="p">],</span> <span class="nb">str</span><span class="p">):</span>
                <span class="k">assert</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">sample</span><span class="p">,</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">),</span> <span class="p">(</span>
                    <span class="s2">&quot;the samples must be a Pandas dataframe in order &quot;</span>
                    <span class="s2">&quot;to retrieve the weights&quot;</span><span class="p">)</span>
                <span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Weights </span><span class="si">{weights[i]}</span><span class="s2"> retrieved&quot;</span><span class="p">)</span>
                <span class="n">weights</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="o">=</span> <span class="n">sample</span><span class="p">[</span><span class="n">weights</span><span class="p">[</span><span class="n">i</span><span class="p">]]</span>

        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">sample</span><span class="p">,</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">):</span>
            <span class="n">list_samples_column</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">sample</span><span class="p">[</span><span class="n">column</span><span class="p">])</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">list_samples_column</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">sample</span><span class="p">)</span>

    <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">bins</span><span class="p">,</span> <span class="nb">int</span><span class="p">):</span>
        <span class="c1"># Loop to determine the low and high values</span>
        <span class="n">low</span><span class="p">,</span> <span class="n">high</span> <span class="o">=</span> <span class="n">compute_low_high</span><span class="p">(</span><span class="n">list_samples_column</span><span class="p">,</span> <span class="n">low</span><span class="p">,</span> <span class="n">high</span><span class="p">)</span>

    <span class="c1"># Get the histograms</span>
    <span class="n">list_counts</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">list_err</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">sample</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">list_samples_column</span><span class="p">):</span>
        <span class="n">weights_sample</span> <span class="o">=</span> <span class="kc">None</span> <span class="k">if</span> <span class="n">weights</span> <span class="ow">is</span> <span class="kc">None</span> <span class="k">else</span> <span class="n">weights</span><span class="p">[</span><span class="n">k</span><span class="p">]</span>
        <span class="n">counts</span><span class="p">,</span> <span class="n">edges</span><span class="p">,</span> <span class="n">err</span> <span class="o">=</span> <span class="n">get_counts_err</span><span class="p">(</span>
            <span class="n">sample</span><span class="o">=</span><span class="n">sample</span><span class="p">,</span> <span class="n">bins</span><span class="o">=</span><span class="n">bins</span><span class="p">,</span>
            <span class="n">low</span><span class="o">=</span><span class="n">low</span><span class="p">,</span> <span class="n">high</span><span class="o">=</span><span class="n">high</span><span class="p">,</span>
            <span class="n">weights</span><span class="o">=</span><span class="n">weights_sample</span><span class="p">,</span>
            <span class="n">density</span><span class="o">=</span><span class="n">density</span><span class="p">,</span>
            <span class="n">equal_yield_bins</span><span class="o">=</span><span class="n">equal_yield_bins</span><span class="p">,</span>
            <span class="o">**</span><span class="n">kwargs</span>
        <span class="p">)</span>

        <span class="n">list_counts</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">counts</span><span class="p">)</span>
        <span class="n">list_err</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">err</span><span class="p">)</span>
        <span class="n">bins</span> <span class="o">=</span> <span class="n">edges</span>
        <span class="n">low</span><span class="p">,</span> <span class="n">high</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span> <span class="kc">None</span>

    <span class="k">return</span> <span class="n">list_counts</span><span class="p">,</span> <span class="n">list_err</span><span class="p">,</span> <span class="n">edges</span></div>
</pre></div>

           </div>
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright .</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>